package com.titan.client;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.ejb.CreateException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

import com.titan.travelagent.TravelAgent;
import com.titan.travelagent.TravelAgentHome;

/**
 * @author Mikalai Zaikin
 */
public class ReservationClient {

	public static void main(String[] args) {
		if (args.length < 3) {
			System.out.println("Define firstName, lastName, cruise");
			System.exit(0);
		}

		String firstName = args[0];
		String lastName = args[1];
		String cruise = args[2];

		Context initialContext = null;
		TravelAgent agent = null;
		TravelAgentHome agentHome = null;
		Object home = null;

		try {
			Hashtable env = new Hashtable();
			env.put(Context.INITIAL_CONTEXT_FACTORY, "com.ibm.websphere.naming.WsnInitialContextFactory");
			env.put(Context.PROVIDER_URL, "iiop://localhost:2809/");
			initialContext = (Context) new InitialContext(env);
			home = initialContext.lookup("java:comp/env/ejb/TravelAgent");
		} catch (NamingException ne) {
			System.out.println("ReservationClient: can not lookup TravelAgentHome " + ne);
			try {
				initialContext.close();
			} catch (NamingException e) {
				System.out.println("ReservationClient: can not close JNDI Context " + e);
				return;
			}
			return;
		}

		agentHome = (TravelAgentHome) PortableRemoteObject.narrow(home, TravelAgentHome.class);

		try {
			agent = (TravelAgent) agentHome.create();
		} catch (CreateException ce) {
			System.out.println("ReservationClient: can not create TravelAgent " + ce);
			return;
		} catch (RemoteException re) {
			System.out.println("ReservationClient: remote exception" + re);
			return;
		}

		try {
			agent.sendReservation(firstName, lastName, cruise);
		} catch (RemoteException e) {
			System.out.println("ReservationClient: remote exception" + e);
			return;
		}

		System.out.println("ReservationClient: Done !");
	}
}
