package com.titan.filters;

import java.io.IOException;
import java.util.Date;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;

/**
 * @version 	1.0
 * @author		Mikalai Zaikin
 */
public class LoggingFilter implements Filter {
	/**
	* @see javax.servlet.Filter#void ()
	*/
	public void destroy() {
	}

	/**
	* @see javax.servlet.Filter#void (javax.servlet.ServletRequest, javax.servlet.ServletResponse, javax.servlet.FilterChain)
	*/
	public void doFilter(ServletRequest req, ServletResponse resp, FilterChain chain) throws ServletException, IOException {
		Date startTime = new Date();
		// Forward the request to the next resource in the chain
		chain.doFilter(req, resp);
		// Calculate the difference between the start time and end time
		Date endTime = new Date();
		double totalTime = endTime.getTime() - startTime.getTime();
		totalTime = totalTime / 1000; //Convert from milliseconds to seconds
		StringBuffer message = new StringBuffer("LoggingFilter: request to : ");
		message.append(((HttpServletRequest) req).getServletPath());
		message.append(" took ");
		message.append(totalTime);
		message.append(" seconds");
		System.out.println(message.toString());
	}

	/**
	* Method init.
	* @param config
	* @throws javax.servlet.ServletException
	*/
	public void init(FilterConfig config) throws ServletException {
	}
}
