package com.titan.servlets;

import java.io.IOException;

import javax.ejb.CreateException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.titan.travelagent.TravelAgent;
import com.titan.travelagent.TravelAgentHome;

/**
 * @version 	1.0
 * @author		Mikalai Zaikin
 */
public class ReservationController extends HttpServlet {

	/**
	* @see javax.servlet.http.HttpServlet#void (javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	*/
	public void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		doPost(req, resp);
	}

	/**
	* @see javax.servlet.http.HttpServlet#void (javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	*/
	public void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		String firstName = req.getParameter("firstName");
		String lastName = req.getParameter("lastName");
		String cruise = req.getParameter("cruise");
		Context env = null;
		TravelAgent agent = null;
		TravelAgentHome agentHome = null;
		Object home = null;
		try {
			env = (Context) new InitialContext();
			home = env.lookup("ejb/com/titan/travelagent/TravelAgentHome");
		} catch (NamingException ne) {
			log("ReservationController: can not lookup TravelAgentHome", ne);
			try {
				env.close();
			} catch (NamingException e) {
				log("ReservationController: can not close JNDI Context", e);
			}
		}

		agentHome = (TravelAgentHome) PortableRemoteObject.narrow(home, TravelAgentHome.class);

		try {
			agent = (TravelAgent) agentHome.create();
		} catch (CreateException ce) {
			log("ReservationController: can not create TravelAgent", ce);
		}
		
		agent.sendReservation(firstName, lastName, cruise);
		RequestDispatcher dispatch = req.getRequestDispatcher("/index.jsp");
		dispatch.forward(req, resp);
	}

}
